Cinema01:

	bsr	FillBlackBuffer
	bsr	BufferToScreen

	bsr	ClearScreenG			;flash screen
	bsr	BufferToScreen

	move.b 	#$ff,d3				;Set mask for the
						;routine "Put_Sprite_Mask"
	move.w 	#50,EyesY			;y coordinate
	move.w 	#48,EyesX			;x coordinate

	move.w	#3,d4				;sprite offset for animation
	move.b	#1,d5				;If d5=0 then eyes close
						;else eyes open
	bsr	Cinema01_DrawBlink

	move.w	#0,d4				;set offset to 0 (open eye)
Cinema01_MoveEyeLoop:				;eye slides up the screen
	bsr	FillBlackBuffer
	sub.w	#2,EyesY
	move.w	EyesY,d1			;set coordinates
	move.w	EyesX,d0
	lea 	EyeLeft1_a(pc),a0		;draw the eyes to buffer
	bsr	Cinema01_DrawEyes
	add.w	#40,d0
	lea 	EyeRight1_a(pc),a0
	bsr	Cinema01_DrawEyes
	bsr	BufferToScreen
	cmp.w	#15,EyesY
	bgt	Cinema01_MoveEyeLoop

	bsr	CinemaTextWindow		;write the cinema text
	lea	Cinema01Text1(pc),a2
	move.l	#15,d3
	move.w	#32,d5
	bsr	WriteWindowText

	bsr	FillBlackBuffer

	move.b 	#$ff,d3				;Set mask for the
						;routine "Put_Sprite_Mask"

	move.w	#0,d4				;sprite offset for animation
	move.b	#0,d5				;If d5=0 then eyes close
						;else eyes open
	bsr	Cinema01_DrawBlink

	bsr	FillBlackBuffer
	bsr	BufferToScreen


	rts




;-------------------------------
;Cinema 1 Routines
;-------------------------------
Cinema01_DrawBlink:
	move.w	#3,d6				;set up a loop
Cinema01_DrawEyeLoop:
	bsr	FillBlackBuffer
	move.w 	EyesY,d1			;copy y coordinate
	move.w 	EyesX,d0			;copy x coordinate
	lea 	EyeLeft1_a(pc),a0		;draw the eyes to buffer
	bsr	Cinema01_DrawEyes
	add.w	#40,d0
	lea 	EyeRight1_a(pc),a0
	bsr	Cinema01_DrawEyes

	bsr	BufferToScreen
	cmp.b	#0,d5
	beq	Cinema01_CloseEyes
Cinema01_OpenEyes:
	sub.w	#1,d4
	bra	Cinema01_EyesDone
Cinema01_CloseEyes:
	add.w	#1,d4
Cinema01_EyesDone:
	move.w	#10,d2
	bsr	Delay
	dbra	d6,Cinema01_DrawEyeLoop
	rts

Cinema01_DrawEyes:				;	input a0=EyeLeft1_a
	move.l 	vid1_addr,a1			;or	input a0=EyeRight1_a
	move.w	d4,d2
	mulu	#104,d2
	adda.l	d2,a0
	jsr 	graphlib::put_sprite_mask
	move.l 	vid2_addr,a1
	adda.l 	#52,a0
	jsr 	graphlib::put_sprite_mask
	rts

CinemaTextWindow:

	move.w	#24,d0				;draws the grayscale text box
	move.w	#50,d1
	move.w	#112,d2
	move.w	#49,d3
	move.l	gplane0,a2
	move.l	gplane1,a3
	bsr	DrawWindow
	rts

EyesX	dc.w	0
EyesY	dc.w	0
