;Routines for Kairi's Quest 89

;****************************************************
;each line of text must be 16 bytes long plus terminating null
;	Registers used:
;		a2.l = string pointer
;		d3.l = number of strings
;		d5.w = x coordinate

WriteWindowText:
	move.w	#1,d0
	bsr	Setfont

	divu	#3,d3
	move.w	d3,d4		;d4 contains number of full sets of 3 strings
				;b/c the window only shows three lines at a time
	swap	d3		;d3 contains any remainder
	cmp.w	#0,d4
	beq	WriteWindowSetDone
	sub.w	#1,d4
WriteWindowText2:			;text loop

	move.w 	#124,d0			;erase text indicator
	move.w 	#90,d1
	lea 	blank(pc),a0
	move.b 	#$00,d3
	move.l 	gplane0,a1
	jsr 	graphlib::put_sprite_mask

	move.w	#56,d6
	bsr	PutWindowText
	adda.l	#17,a2			;shift text forward to next line

	move.w	#70,d6
	bsr	PutWindowText
	adda.l	#17,a2			;shift text forward to next line

	move.w	#84,d6
	bsr	PutWindowText
	adda.l	#17,a2			;shift text forward to next line

	move.w 	#124,d0			;draw text indicator
	move.w 	#90,d1
	lea 	textpoint(pc),a0
	move.b 	#$00,d3
	move.l 	gplane0,a1
	jsr 	graphlib::put_sprite_mask


	jsr	userlib::idle_loop
	bsr	ClearLines

	dbra	d4,WriteWindowText2
WriteWindowSetDone:
	move.w 	#124,d0			;erase text indicator
	move.w 	#90,d1
	lea 	blank(pc),a0
	move.b 	#$00,d3
	move.l 	gplane0,a1
	jsr 	graphlib::put_sprite_mask



	cmp.w	#0,d3			;check for remainder
	beq	WriteWindowTextDone


	move.w	#56,d6
	bsr	PutWindowText
	adda.l	#17,a2			;shift text forward to next line

	cmp.w	#1,d3			;check for remainder again
	beq	WriteWindowTextDone2


	move.w	#70,d6
	bsr	PutWindowText

WriteWindowTextDone2:
	jsr	userlib::idle_loop
WriteWindowTextDone:
	rts


PutWindowText:
	move.w	d5,d0
	move.w	d6,d1
	move.w	#4,d2
	move.l	a2,a0
	bsr	Putchar
	rts

ClearLines:
	move.l	a2,a3
	lea	Blank(pc),a2
	move.w	#56,d6
	bsr	PutWindowText
	move.w	#70,d6
	bsr	PutWindowText
	move.w	#84,d6
	bsr	PutWindowText
	move.l	a3,a2
	rts

;****************************************************



;Setfont: Sets the font being used
;	Registers Used:
;		d0.w = font

Setfont:
        move.w  d0,-(a7)
        jsr     tios::FontSetSys
        addq    #2,a7
	rts

;****************************************************

;Putchar: Uses the tios::DrawStrXY to output text to the screen, but is done this
;way so that the pushing and popping doesn't have to be reused everytime
;
;	Registers Used:
;		d0.w = x
;		d1.w = y
;		d2.w = style
;		a0.l = string pointer

Putchar:
        move.w  d2,-(a7)
        move.l  a0,-(a7)
        move.w  d1,-(a7)
        move.w  d0,-(a7)
        jsr     tios::DrawStrXY
        add.l   #10,a7
	rts

;****************************************************

Keywait:
        tst.w   tios::kb_globals+$1c		;check for key
        beq     Keywait				;no key pressed, then loop
        move.w  tios::MaxHandles+$1e,d4		;store keypress in d4
        clr.w   tios::kb_globals+$1c
	rts

;****************************************************

ClearScreenG:
	move.l 	gplane0,a1
	jsr 	graphlib::clr_scr
	move.l 	gplane1,a1
	jsr 	graphlib::clr_scr
	rts

;****************************************************

PutSpriteG:				;CURRENTLY NOT NEEDED
;Input:	d0.w = x			;just uncomment to make it usable
;	d1.w = y
;	a0.l = adress of the sprite
;	move.l	a0,a2
;	adda.l	#72,a2
;	move.l	gplane0,a1
;	jsr	graphlib::put_sprite2
;	adda.l	#36,a0
;	move.l	gplane1,a1
;	jsr	graphlib::put_sprite2
;	rts

;****************************************************
;copies grayscale sprite to the two buffers
PutSpriteBuffer:
;Input:	d0.w = x
;	d1.w = y
;	a0.l = adress of the sprite
	move.l	a0,a2
	adda.l	#72,a2
	move.l	vid1_addr,a1
	jsr	graphlib::put_sprite2
	adda.l	#36,a0
	move.l	vid2_addr,a1
	jsr	graphlib::put_sprite2
	rts

;****************************************************
;copies both buffers to screen, grayscale
BufferToScreen:
	move.l	gplane0,a1
	move.l	vid1_addr,a0
        move.l  #3839,d1                ; Bytes to copy -1 into D1
	bsr	copy_buffer
	move.l	gplane1,a1
	move.l	vid2_addr,a0
        move.l  #3839,d1                ; Bytes to copy -1 into D1
	bsr	copy_buffer
	rts

copy_buffer:
        move.b  (a0),d0                 ; Move a byte from buffer to video RAM,
        move.b  d0,(a1)                 ; increment pointers to both, and repeat
        addq.l  #1,a0                   ; for all bytes
        addq.l  #1,a1
        dbra    d1,copy_buffer
        rts

;****************************************************
;fills screen with black
;inputs:	a1 = screen address

FillBlack:
        move.l  #3839,d1                ; Bytes to copy -1 into D1
CopyBlackByte:
        move.b  #$ff,(a1)                 ; copy filled byte to address
        addq.l  #1,a1
        dbra    d1,CopyBlackByte
        rts
;****************************************************

ClearScreenBuffer:
	move.l	vid1_addr,a1
	jsr 	graphlib::clr_scr
	move.l	vid2_addr,a1
	jsr 	graphlib::clr_scr
	rts

;****************************************************
;inputs:
;	a2	- layer 1 (gray)
;	a3	- layer 2 (gray)
;	(d0,d1)	- coordinates
;	d2	- width
;	d3	- height


DrawWindow:
	move.w	#2,d4
	move.l	a3,a1
	jsr 	graphlib::fill
	move.l 	a2,a1
	jsr 	graphlib::fill
	add.w	#1,d0
	add.w	#1,d1
	sub.w	#2,d2
	sub.w	#2,d3
	move.w	#1,d4

	jsr 	graphlib::fill
	add.w	#1,d0
	add.w	#1,d1
	sub.w	#2,d2
	sub.w	#2,d3

	move.l 	a3,a1
	jsr 	graphlib::fill
	move.l 	gplane1,a0
	rts
;****************************************************
;input d2=delay time
Delay:
	nop
	dbra	d2,Delay
	rts

;****************************************************
DrawTextWindow:

	move.w	#0,d0				;draws the grayscale text box
	move.w	#50,d1
	move.w	#112,d2
	move.w	#49,d3
	move.l	gplane0,a2
	move.l	gplane1,a3
	bsr	DrawWindow
	rts
;****************************************************

FillBlackBuffer:
	move.l	vid1_addr,a1			;clear screen to black
	bsr 	FillBlack
	move.l	vid2_addr,a1
	bsr 	FillBlack
	rts

;****************************************************
;draws the tiled screen to the buffers
;a0 = start of level data

DrawScreen:
	move.w	#0,d0		;set a loop to 0 (y coordinate of level)

DrawScreenRow:
	move.w	#0,d1		;set a loop to 0 (x coordinate of level)
DrawScreenTile:
	move.w	d0,d2		;find offset (where byte 0 would be beginning of screen mem)
	mulu	#240,d2
	add.w	d1,d2		;d2 contains offset

	move.w	(a0),d3		;get tile address according to level data
	mulu	#16,d3
	lea	Tiles(pc),a2
	adda.w	d3,a2		;a2 contains tile address
	adda.l	#2,a0		;shift a0 to the next piece of level data

	move.l	vid1_addr,a1
	adda.w	d2,a1		;a1 contains the starting address to draw to
	move.w	#7,d4
DrawTile1:			;draw to plane1
	move.b	(a2),(a1)
	adda.l	#1,a2		;shift tile data to next byte
	adda.l	#30,a1		;shift drawing address to next line
	dbra	d4,DrawTile1

	move.l	vid2_addr,a1
	adda.w	d2,a1		;a1 contains the starting address to draw to
	move.w	#7,d4
DrawTile2:			;draw to plane2
	move.b	(a2),(a1)
	adda.l	#1,a2		;shift tile data to next byte
	adda.l	#30,a1		;shift drawing address to next line
	dbra	d4,DrawTile2

	add.w	#1,d1
	cmp.w	#14,d1
	bne	DrawScreenTile

	add.w	#1,d0
	cmp.w	#12,d0
	bne	DrawScreenRow

	rts

;****************************************************
;Erases a sprite
;	(d0.w , d1.w) = (x,y)
;	a0 = start of level data

EraseSprite:
	move.w	#0,d2		;start a loop from 0 to 2 (erase three tiles down)
EraseRow:
	move.w	d1,d5
        and.l   #$0000FFFF,d5
	divu	#8,d5
        and.l   #$0000FFFF,d5
	add.w	d2,d5		;get y coordinate aligned to a tile
	move.w	d5,d6		;d6=aligned y to a tile
	mulu	#28,d6
	cmp.w	#12,d5
	bge	EraseRowDone
	mulu	#240,d5		;get screen address offset in d5


	move.w	#0,d3		;start a loop from 0 to 2 (erase three tiles across)
EraseCol:
	move.w	d0,d4
        and.l   #$0000FFFF,d4
	divu	#8,d4
        and.l   #$0000FFFF,d4
	add.w	d3,d4		;d4 contains x in bytes
	cmp.w	#14,d4
	bge	EraseColDone


	move.l	a0,a2
	move.w	d4,d7
	mulu	#2,d7
	add.l	d6,d7
	adda.l	d7,a2		;a2 = level data address
	move.w	(a2),d7		;d7 now contains the level data piece	

;-------
	mulu	#16,d7
	lea	Tiles(pc),a2
	adda.l	d7,a2		;a2 contains tile address

	move.l	vid1_addr,a1
	add.w	d5,d4
	adda.w	d4,a1		;a1 contains the starting address to draw to
	move.w	#7,d7
DoErase1:			;draw to plane1
	move.b	(a2),(a1)
	adda.l	#1,a2		;shift tile data to next byte
	adda.l	#30,a1		;shift drawing address to next line
	dbra	d7,DoErase1

	move.l	vid2_addr,a1
	adda.w	d4,a1		;a1 contains the starting address to draw to
	move.w	#7,d7
DoErase2:			;draw to plane2
	move.b	(a2),(a1)
	adda.l	#1,a2		;shift tile data to next byte
	adda.l	#30,a1		;shift drawing address to next line
	dbra	d7,DoErase2
;-------
EraseColDone:
	add.w	#1,d3
	cmp.w	#3,d3
	bne	EraseCol

EraseRowDone:
	add.w	#1,d2
	cmp.w	#3,d2
	bne	EraseRow
	rts

;****************************************************
;Gets the tile at a certain point
;registers:
;	(d0.w,d1.w) = point
;	a0 = start of level data
;Returns:
;	d2.w = tile index
CheckPoint:
        and.l   #$0000FFFF,d1
	divu	#8,d1
        and.l   #$0000FFFF,d1
	mulu	#28,d1

        and.l   #$0000FFFF,d0
	divu	#8,d0
        and.l   #$0000FFFF,d0
	mulu	#2,d0

	add.l	d0,d1
	adda.l	d1,a0		;a0 = level data address
	move.w	(a0),d2		;d2 now contains the level data piece	

	rts